// ローンシミュレーション（借入可能金額算出） ver1.0
// 
// E-Mail: info@sitetool.biz
// Web   : http://www.sitetool.biz
// (C) 不動産WEBサイトツール
// 
// 上記著作権表示部は改変不可です。
// その他スクリプト部分は改変可です。

var hikaku = Class.create({
    initialize: function(elm) {
        
        // エラー格納用変数
        this.errors = [];
        this.error_elm = '';
        
        // 出力エリアのID
        this.elm = elm;
        
        // 計算結果格納用
        this.results = {};
        
        // 入力フォームを出力
        this.putForm();
        // イベントリスナ登録
        this.setEventHandlers();
    },
    // ボタンのイベントリスナ
    setEventHandlers: function() {
        this.clearHandler = this.clearForm.bind(this);
        $('fwt_clear').observe('click', this.clearHandler);
        this.calcHandler = this.calcForm.bind(this);
        $('fwt_calc').observe('click', this.calcHandler);
    },
    // 各種計算と結果出力
    calcForm: function() {
        this.clearResult();
        this.calcBegin();
        this.checkForm();
        if(this.errors.length > 0) {
            this.alerts();
        }
        else {
            // 各値をキャスト
            var values = {};
            values['compare_year'] = parseInt($('compare_year').value);
            values['fwt_rent_money'] = parseInt($('fwt_rent_money').value);
            values['fwt_renew_money'] = 0;
            if($('fwt_renew_money').value) {
                values['fwt_renew_money'] = parseFloat($('fwt_renew_money').value);
            }
            values['fwt_renew_span'] = parseInt($('fwt_renew_span').value);
            values['fwt_renew_rate'] = 0;
            if($('fwt_renew_rate').value) {
                values['fwt_renew_rate'] = parseFloat($('fwt_renew_rate').value/100);
            }
            values['fwt_borrow_money'] = parseInt($('fwt_borrow_money').value * 10000);
            values['fwt_borrow_year'] = parseInt($('fwt_borrow_year').value);
            values['fwt_debt_rate'] = parseFloat($('fwt_debt_rate').value/100);
            
            // 共通変数初期化
            values['fwt_rent_money_month'] = 0;
            values['fwt_rent_money_year'] = 0;
            values['fwt_rent_money_total'] = 0;
            values['fwt_rent_money_average'] = 0;
            values['fwt_buy_money_month'] = 0;
            values['fwt_buy_money_year'] = 0;
            values['fwt_buy_money_total'] = 0;
            values['fwt_buy_money_average'] = 0;
            
            values['fwt_rent_money_month_end'] = 0;
            values['fwt_rent_money_year_end'] = 0;
            values['fwt_rent_money_total_end'] = 0;
            values['fwt_rent_money_average_end'] = 0;
            values['fwt_buy_money_month_end'] = 0;
            values['fwt_buy_money_year_end'] = 0;
            values['fwt_buy_money_total_end'] = 0;
            values['fwt_buy_money_average_end'] = 0;
            
            if($('fwt_pay_type2').checked == true) {
                this.results = this.calcGankinKintou(values);
                // 結果出力
                this.putResults();
            }
            else {
                this.results = this.calcGanriKintou(values);
                // 結果出力
                this.putResults();
            }
            
        }
    },
    // 元金均等
    calcGankinKintou: function(values) {
        
        // ==================== 支払家賃 ====================
        var values_chintai = this.calcChintai(values);
        for(k in values_chintai) {
            values[k] = values_chintai[k];
        }
        var values_chintai_end = this.calcChintaiEnd(values);
        for(k in values_chintai_end) {
            values[k] = values_chintai_end[k];
        }
        
        // ==================== 住宅購入 ====================
        
        values['fwt_pay_type'] = 2;
        
        // 定額支払（月払分）
        values['buy_money_flat'] = Math.round(values['fwt_borrow_money'] / (values['fwt_borrow_year'] * 12));
        
        // （入力された比較時期）
        
        // 月ごと支払（月払分）
        values['fwt_buy_money_months'] = new Array();
        values['fwt_borrow_money_balance'] = values['fwt_borrow_money'];
        for(var i=1; i <= values['compare_year']; i++) {
            values['fwt_buy_money_months'][i] = new Array();
            for(var j=1; j<=12; j++) {
                values['fwt_buy_money_months'][i][j] = Math.round(values['fwt_borrow_money_balance'] * (values['fwt_debt_rate'] / 12) + values['buy_money_flat']);
                // 総支払額
                values['fwt_buy_money_total'] += values['fwt_buy_money_months'][i][j];
                values['fwt_borrow_money_balance'] -= values['buy_money_flat'];
            }
        }
        
        // 月
        values['fwt_buy_money_month'] = values['fwt_buy_money_months'][(values['compare_year'])][1];
        
        // 年
        for(var j=1; j<=12; j++) {
            values['fwt_buy_money_year'] += values['fwt_buy_money_months'][(values['compare_year'])][j];
        }
        
        // 月平均
        values['fwt_buy_money_average'] = Math.round(values['fwt_buy_money_total'] / 12 / values['compare_year']);
        
        // （住宅購入費用完済時）
        
        // 月ごと支払（月払分）
        values['fwt_buy_money_months'] = new Array();
        values['fwt_borrow_money_balance'] = values['fwt_borrow_money'];
        for(var i=1; i <= values['fwt_borrow_year']; i++) {
            values['fwt_buy_money_months'][i] = new Array();
            for(var j=1; j<=12; j++) {
                values['fwt_buy_money_months'][i][j] = Math.round(values['fwt_borrow_money_balance'] * (values['fwt_debt_rate'] / 12) + values['buy_money_flat']);
                // 総支払額
                values['fwt_buy_money_total_end'] += values['fwt_buy_money_months'][i][j];
                values['fwt_borrow_money_balance'] -= values['buy_money_flat'];
            }
        }
        
        // 月
        values['fwt_buy_money_month_end'] = values['fwt_buy_money_months'][(values['fwt_borrow_year'])][1];
        
        // 年
        for(var j=1; j<=12; j++) {
            values['fwt_buy_money_year_end'] += values['fwt_buy_money_months'][(values['fwt_borrow_year'])][j];
        }
        
        // 月平均
        values['fwt_buy_money_average_end'] = Math.round(values['fwt_buy_money_total_end'] / 12 / values['fwt_borrow_year']);
        
        return values;
    },
    // 元利均等
    calcGanriKintou: function(values) {
        
        // ==================== 支払家賃 ====================
        var values_chintai = this.calcChintai(values);
        for(k in values_chintai) {
            values[k] = values_chintai[k];
        }
        var values_chintai_end = this.calcChintaiEnd(values);
        for(k in values_chintai_end) {
            values[k] = values_chintai_end[k];
        }
        
        // ==================== 住宅購入 ====================
        
        values['fwt_pay_type'] = 1;
        
        // （入力された比較時期）
        
        // 月
        values['fwt_buy_money_month'] = Math.round(values['fwt_borrow_money'] * values['fwt_debt_rate']/12 * Math.pow(1+values['fwt_debt_rate']/12,values['fwt_borrow_year']*12) / (Math.pow((1+values['fwt_debt_rate']/12),(values['fwt_borrow_year']*12))-1));
        // 年
        values['fwt_buy_money_year'] = values['fwt_buy_money_month'] * 12;
        // 総支払額
        values['fwt_buy_money_total'] = values['fwt_buy_money_month'] * 12 * values['compare_year'];
        // 月平均
        values['fwt_buy_money_average'] = Math.round(values['fwt_buy_money_total'] / 12 / values['compare_year']);
        
        // （住宅購入費用完済時）
        
        // 月
        values['fwt_buy_money_month_end'] = values['fwt_buy_money_month'];
        // 年
        values['fwt_buy_money_year_end'] = values['fwt_buy_money_month_end'] * 12;
        // 総支払額
        values['fwt_buy_money_total_end'] = values['fwt_buy_money_month_end'] * 12 * values['fwt_borrow_year'];
        // 月平均
        values['fwt_buy_money_average_end'] = Math.round(values['fwt_buy_money_total_end'] / 12 / values['fwt_borrow_year']);
        
        return values;
    },
    calcChintai: function(values) {
        // 月額
        values['fwt_rent_money_month'] = values['fwt_rent_money'];
        
        // 更新費用合計
        values['fwt_renew_money_total'] = 0;
        
        // 更新費用と値上げ計算
        var rent_money_month_total = 0;
        var update_flg = 0;
        for(var i=1; i<=values['compare_year']; i++) {
            
            update_flg = 0;
            
            if(values['fwt_renew_span'] > 0 && (i+1)%values['fwt_renew_span'] == 0) {
                update_flg = 1;
            }
            
            // 値上げ反映
            if(update_flg == 1 && values['fwt_renew_span'] && values['fwt_renew_rate']) {
                values['fwt_rent_money_month'] += Math.round(values['fwt_rent_money_month'] * values['fwt_renew_rate']);
            }
            
            rent_money_month_total += values['fwt_rent_money_month'] * 12;
            
            // 更新費用
            if(update_flg == 1) {
                values['fwt_renew_money_total'] += Math.round(values['fwt_renew_money'] * values['fwt_rent_money_month']);
            }
        }
        
        // 年額
        values['fwt_rent_money_year'] = Math.round(values['fwt_rent_money_month'] * 12);
        // 総支払額
        values['fwt_rent_money_total'] = Math.round(rent_money_month_total + values['fwt_renew_money_total']);
        // 月平均
        values['fwt_rent_money_average'] = Math.round(values['fwt_rent_money_total'] / 12 / values['compare_year']);
        
        return values;
    },
    calcChintaiEnd: function(values) {
        // 月額
        values['fwt_rent_money_month_end'] = values['fwt_rent_money'];
        
        // 更新費用合計
        values['fwt_renew_money_total_end'] = 0;
        
        // 更新費用と値上げ計算
        var rent_money_month_total = 0;
        var update_flg = 0;
        for(var i=1; i<=values['fwt_borrow_year']; i++) {
            
            update_flg = 0;
            
            if(values['fwt_renew_span'] > 0 && (i+1)%values['fwt_renew_span'] == 0) {
                update_flg = 1;
            }
            
            // 値上げ反映
            if(update_flg == 1 && values['fwt_renew_span'] && values['fwt_renew_rate']) {
                values['fwt_rent_money_month_end'] += Math.round(values['fwt_rent_money_month_end'] * values['fwt_renew_rate']);
            }
            
            rent_money_month_total += values['fwt_rent_money_month_end'] * 12;
            
            // 更新費用
            if(update_flg == 1) {
                values['fwt_renew_money_total_end'] += Math.round(values['fwt_renew_money'] * values['fwt_rent_money_month_end']);
            }
        }
        
        // 年額
        values['fwt_rent_money_year_end'] = Math.round(values['fwt_rent_money_month_end'] * 12);
        // 総支払額
        values['fwt_rent_money_total_end'] = Math.round(rent_money_month_total + values['fwt_renew_money_total_end']);
        // 月平均
        values['fwt_rent_money_average_end'] = Math.round(values['fwt_rent_money_total_end'] / 12 / values['fwt_borrow_year']);
        
        return values;
    },
    // 入力フォーム出力
    putForm: function() {
        var html = '';
        html += '<p id="fwt_caption_input">賃貸住宅と住宅購入の比較シミュレーションをします</p>';
        html += '<div id="fwt_explane">';
        html += '<p>※下記フォームを入力し、「計算」ボタンをクリックしてください。</p>';
        html += '<p>※計算結果は概算です。あくまで参考としてご利用ください。</p>';
        html += '</div>';
        html += '<form name="fwt_hikakuForm" id="fwt_hikakuForm">';
        html += '<div id="fwt_inputs">';
        html += '<table>';
        html += '<tr>';
        html += '<th colspan="2"><div class="fwt_table_captin">比較内容</div></th>';
        html += '</tr>';
        html += '<tr>';
        html += '<th>比較時期<span class="fwt_need">必須</span></th>';
        html += '<td>'+this.makeCompareYear('compare_year')+' 年目<div class="fwt_note">※住宅購入費用の返済期間以下で入力してください</div></td>';
        html += '</tr>';
        html += '</table>';
        html += '<table>';
        html += '<tr>';
        html += '<th colspan="2"><div class="fwt_table_captin">賃貸住宅の費用</div></th>';
        html += '</tr>';
        html += '<tr>';
        html += '<th>毎月の家賃<span class="fwt_need">必須</span></th>';
        html += '<td><input type="text" name="fwt_rent_money" id="fwt_rent_money" value="" size="15" /> 円<div class="fwt_note">1～999999</div><div class="fwt_note">※家賃以外の月額費用（管理費など）も含めてください</div></td>';
        html += '</tr>';
        html += '<tr>';
        html += '<th>契約更新費用</th>';
        html += '<td><input type="text" name="fwt_renew_money" id="fwt_renew_money" value="" size="10" /> ヶ月分<div class="fwt_note">0.1～9.9</div></td>';
        html += '</tr>';
        html += '<tr>';
        html += '<th>契約更新頻度</th>';
        html += '<td>'+this.makeRenewSpan('fwt_renew_span')+' 年ごと</td>';
        html += '</tr>';
        html += '<tr>';
        html += '<th>契約更新時の値上率</th>';
        html += '<td><input type="text" name="fwt_renew_rate" id="fwt_renew_rate" value="" size="10" /> ％<div class="fwt_note">0.1～99.9</div></td>';
        html += '</tr>';
        html += '</table>';
        html += '<table>';
        html += '<tr>';
        html += '<th colspan="2"><div class="fwt_table_captin">住宅購入時の費用</div></th>';
        html += '</tr>';
        html += '<tr>';
        html += '<th>借入金額<span class="fwt_need">必須</span></th>';
        html += '<td><input type="text" name="fwt_borrow_money" id="fwt_borrow_money" value="" size="10" /> 万円<div class="fwt_note">1～99999</div></td>';
        html += '</tr>';
        html += '<tr>';
        html += '<th>返済期間<span class="fwt_need">必須</span></th>';
        html += '<td>'+this.makeBorrowYear('fwt_borrow_year')+' 年</td>';
        html += '</tr>';
        html += '<tr>';
        html += '<th>金利<span class="fwt_need">必須</span></th>';
        html += '<td><input type="text" name="fwt_debt_rate" id="fwt_debt_rate" value="" size="10" /> ％ <div class="fwt_note">0.01～99.99</div></td>';
        html += '</tr>';
        html += '<tr>';
        html += '<th>返済方式</th>';
        html += '<td><input type="radio" name="fwt_pay_type" id="fwt_pay_type1" value="1" checked="checked" /><label for="fwt_pay_type1"> 元利均等</label><input type="radio" name="fwt_pay_type" id="fwt_pay_type2" value="2" /><label for="fwt_pay_type2"> 元金均等</label></td>';
        html += '</tr>';
        html += '</table>';
        html += '<div id="fwt_buttons"><input type="button" name="fwt_clear" id="fwt_clear" value="クリア" /> <input type="button" name="fwt_calc" id="fwt_calc" value="計算" /></div>';
        html += '</div>';
        html += '<div id="fwt_results">';
        html += '</div>';
        html += '</form>';
        Element.update($(this.elm),html);
    },
    // 入力フォームの返済期間選択肢（年）
    makeCompareYear: function(name) {
        var html = '';
        if(name) {
            html += '<select name="'+name+'" id="'+name+'">';
            for(var i=1; i<=40; i++) {
                if(i == 15) {
                    html += '<option value="'+i+'" selected="selected">'+i+'</option>';
                }
                else {
                    html += '<option value="'+i+'">'+i+'</option>';
                }
            }
            html += '</select>';
        }
        return html;
    },
    // 入力フォームの返済期間選択肢（年）
    makeBorrowYear: function(name) {
        var html = '';
        if(name) {
            html += '<select name="'+name+'" id="'+name+'">';
            for(var i=1; i<=40; i++) {
                if(i == 25) {
                    html += '<option value="'+i+'" selected="selected">'+i+'</option>';
                }
                else {
                    html += '<option value="'+i+'">'+i+'</option>';
                }
            }
            html += '</select>';
        }
        return html;
    },
    // 契約更新頻度（年）
    makeRenewSpan: function(name) {
        var html = '';
        if(name) {
            html += '<select name="'+name+'" id="'+name+'">';
            html += '<option value=""></option>';
            for(var i=1; i<=20; i++) {
                html += '<option value="'+i+'">'+i+'</option>';
            }
            html += '</select>';
        }
        return html;
    },
    // 結果出力
    putResults: function() {
        
        var note = '';
        if(this.results['fwt_pay_type'] == 2) {
            note = '（初回）';
        }
        
        var html = '';
        html += '<p id="fwt_caption_result">シミュレーション結果</p>';
        html += '<p class="fwt_caption_table">'+this.results['compare_year']+'年目の比較</p>';
        html += '<table>';
        html += '<tr>';
        html += '<th>&nbsp;</th>';
        html += '<th>賃貸</th>';
        html += '<th>購入</th>';
        html += '<th>差額</th>';
        html += '</tr>';
        html += '<tr>';
        html += '<td>支払額（月）</td>';
        html += '<td>'+this.addComma(this.results['fwt_rent_money_month'])+' 円</td>';
        html += '<td>'+this.addComma(this.results['fwt_buy_money_month'])+' 円'+note+'</td>';
        html += '<td>'+this.addComma(this.results['fwt_rent_money_month']-this.results['fwt_buy_money_month'])+' 円</td>';
        html += '</tr>';
        html += '<tr>';
        html += '<td>支払額（年）</td>';
        html += '<td>'+this.addComma(this.results['fwt_rent_money_year'])+' 円</td>';
        html += '<td>'+this.addComma(this.results['fwt_buy_money_year'])+' 円</td>';
        html += '<td>'+this.addComma(this.results['fwt_rent_money_year']-this.results['fwt_buy_money_year'])+' 円</td>';
        html += '</tr>';
        html += '<tr>';
        html += '<td>支払額（総額）</td>';
        html += '<td>'+this.addComma(this.results['fwt_rent_money_total'])+' 円</td>';
        html += '<td>'+this.addComma(this.results['fwt_buy_money_total'])+' 円</td>';
        html += '<td>'+this.addComma(this.results['fwt_rent_money_total']-this.results['fwt_buy_money_total'])+' 円</td>';
        html += '</tr>';
        html += '<tr>';
        html += '<td>支払額（月平均）</td>';
        html += '<td>'+this.addComma(this.results['fwt_rent_money_average'])+' 円</td>';
        html += '<td>'+this.addComma(this.results['fwt_buy_money_average'])+' 円</td>';
        html += '<td>'+this.addComma(this.results['fwt_rent_money_average']-this.results['fwt_buy_money_average'])+' 円</td>';
        html += '</tr>';
        html += '</table>';
        html += '<p class="fwt_caption_table">住宅購入費用完済時の比較（'+this.results['fwt_borrow_year']+'年目）</p>';
        html += '<table>';
        html += '<tr>';
        html += '<th>&nbsp;</th>';
        html += '<th>賃貸</th>';
        html += '<th>購入</th>';
        html += '<th>差額</th>';
        html += '</tr>';
        html += '<tr>';
        html += '<td>支払額（総額）</td>';
        html += '<td>'+this.addComma(this.results['fwt_rent_money_total_end'])+' 円</td>';
        html += '<td>'+this.addComma(this.results['fwt_buy_money_total_end'])+' 円</td>';
        html += '<td>'+this.addComma(this.results['fwt_rent_money_total_end']-this.results['fwt_buy_money_total_end'])+' 円</td>';
        html += '</tr>';
        html += '<tr>';
        html += '<td>支払額（月平均）</td>';
        html += '<td>'+this.addComma(this.results['fwt_rent_money_average_end'])+' 円</td>';
        html += '<td>'+this.addComma(this.results['fwt_buy_money_average_end'])+' 円</td>';
        html += '<td>'+this.addComma(this.results['fwt_rent_money_average_end']-this.results['fwt_buy_money_average_end'])+' 円</td>';
        html += '</tr>';
        html += '</table>';
        html += '<div class="fwt_message">住宅購入の場合、家屋・土地が資産として残りますが、このシミュレーションでは考慮しておりません。</div>';
        Element.update($('fwt_results'),html);
    },
    // 結果クリア
    clearResult: function() {
        Element.update($('fwt_results'),'');
        this.results = {};
    },
    // 入力値クリア
    clearForm: function() {
        $('compare_year').selectedIndex = 15;
        $('fwt_rent_money').value = '';
        $('fwt_renew_money').value = '';
        $('fwt_renew_span').selectedIndex = 0;
        $('fwt_renew_rate').value = '';
        $('fwt_borrow_money').value = '';
        $('fwt_debt_rate').value = '';
        $('fwt_borrow_year').selectedIndex = 25;
        $('fwt_pay_type1').checked = true;
        $('fwt_pay_type2').checked = false;
    },
    // 事前処理（計算・入力値チェックの前）
    calcBegin: function() {
        $('fwt_rent_money').value = this.replaceZennumToHannum($('fwt_rent_money').value);
        $('fwt_renew_money').value = this.replaceZennumToHannum($('fwt_renew_money').value);
        $('fwt_renew_rate').value = this.replaceZennumToHannum($('fwt_renew_rate').value);
        $('fwt_borrow_money').value = this.replaceZennumToHannum($('fwt_borrow_money').value);
        $('fwt_debt_rate').value = this.replaceZennumToHannum($('fwt_debt_rate').value);
    },
    // 入力値チェック
    checkForm: function() {
        this.errors = [];
        this.error_elm = '';
        var name = '';
        
        // 毎月の家賃
        name = '「毎月の家賃」';
        if($('fwt_rent_money').value == '') {
            this.errors.push(name+'を入力してください。');
            this.errorFocus('fwt_rent_money');
        }
        else {
            var err = this.checkNumber($('fwt_rent_money').value,6,0);
            if(err) {
                this.errors.push(name+'は'+err);
                this.errorFocus('fwt_rent_money');
            }
            else {
                if(parseFloat($('fwt_rent_money').value) <= 0) {
                    this.errors.push(name+'は1以上を入力してください。');
                    this.errorFocus('fwt_rent_money');
                }
            }
        }
        
        // 契約更新費用
        name = '「契約更新費用」';
        if($('fwt_renew_money').value != '') {
            var err = this.checkNumber($('fwt_renew_money').value,1,1);
            if(err) {
                this.errors.push(name+'は'+err);
                this.errorFocus('fwt_renew_money');
            }
            if($('fwt_renew_span').value == '') {
                this.errors.push(name+'を入力する場合、「契約更新頻度」も入力してください。');
                this.errorFocus('fwt_renew_span');
            }
        }
        
        // 契約更新時の値上率
        name = '「契約更新時の値上率」';
        if($('fwt_renew_rate').value != '') {
            var err = this.checkNumber($('fwt_renew_rate').value,2,1);
            if(err) {
                this.errors.push(name+'は'+err);
                this.errorFocus('fwt_renew_rate');
            }
            if($('fwt_renew_span').value == '') {
                this.errors.push(name+'を入力する場合、「契約更新頻度」も入力してください。');
                this.errorFocus('fwt_renew_span');
            }
        }
        
        // 借入金額
        name = '「借入金額」';
        if($('fwt_borrow_money').value == '') {
            this.errors.push(name+'を入力してください。');
            this.errorFocus('fwt_borrow_money');
        }
        else {
            var err = this.checkNumber($('fwt_borrow_money').value,5,0);
            if(err) {
                this.errors.push(name+'は'+err);
                this.errorFocus('fwt_borrow_money');
            }
            else {
                if(parseFloat($('fwt_borrow_money').value) <= 0) {
                    this.errors.push(name+'は1以上を入力してください。');
                    this.errorFocus('fwt_borrow_money');
                }
            }
        }
        
        // 金利
        name = '「金利」';
        if($('fwt_debt_rate').value == '') {
            this.errors.push(name+'を入力してください。');
            this.errorFocus('fwt_debt_rate');
        }
        else {
            var err = this.checkNumber($('fwt_debt_rate').value,2,2);
            if(err) {
                this.errors.push(name+'は'+err);
                this.errorFocus('fwt_debt_rate');
            }
            else {
                if(parseFloat($('fwt_debt_rate').value) <= 0) {
                    this.errors.push(name+'は0.01以上を入力してください。');
                    this.errorFocus('fwt_debt_rate');
                }
            }
        }

        if(parseInt($('compare_year').value) > 0 && parseInt($('fwt_borrow_year').value) > 0) {
            if(parseInt($('compare_year').value) > parseInt($('fwt_borrow_year').value)) {
                this.errors.push('「比較時期」は住宅購入費用の「返済期間」以下で入力してください。');
                this.errorFocus('compare_year');
            }
        }
    },
    // 数値チェック
    checkNumber: function(val,int_length,dec_length) {
        // 空
        if(val == '') {
            return '数値を入力してください。';
        }
        // 数字とカンマ以外
        if(val.match(/[^0-9|^.]/g)) {
            return '数値を入力してください。';
        }
        // カンマの数
        var cnt = 0;
        for(var i=0; i<val.length; i++) {
            if(val.charAt(i) == '.') {
                cnt++;
            }
        }
        if(cnt > 1) {
            return '正しい数値を入力してください。';
        }
        // 先頭カンマ
        if(val.charAt(0) == '.') {
            return '正しい数値を入力してください。';
        }
        // 整数部分の桁数
        if(int_length > 0) {
            var int_str = '';
            if(cnt == 1) {
                int_str = val.substring(0, val.indexOf('.'));
            }
            else {
                int_str = val;
            }
            if(int_str.length > int_length) {
                return '整数部分を'+int_length+'桁以下で入力してください。';
            }
        }
        // 小数部分の桁数
        if(dec_length > 0) {
            var dec_str = '';
            if(cnt == 1) {
                var idx = val.indexOf('.');
                dec_str = val.substring(idx);
                if(dec_str.length-1 > dec_length) {
                    return '小数部分を'+dec_length+'桁以下で入力してください。';
                }
            }
        }
        else {
            if(cnt == 1) {
                return '整数を入力してください。';
            }
        }
        return false;
    },
    // 全角数字＆ドットを半角に置換
    replaceZennumToHannum: function(chars) {
        var zennums = new Array('０','１','２','３','４','５','６','７','８','９','．');
        var hannums = new Array(0,1,2,3,4,5,6,7,8,9,'.');
        for(var i=0; i<11; i++) {
            chars = chars.replace(new RegExp(zennums[i],'g'),hannums[i]); 
        }
        return chars;
    },
    // カンマ付加
    addComma: function(str) {
        var num = new String(str).replace(/,/g, "");
        while(num != (num = num.replace(/^(-?\d+)(\d{3})/, "$1,$2")));
        return num;
    },
    // アラート出力
    alerts: function() {
        if(this.errors.length > 0) {
            var txt = '';
            for(var i=0; i<this.errors.length; i++) {
                txt += this.errors[i]+"\n";
            }
            if(this.error_elm != '') {
                $(this.error_elm).focus();
            }
            alert(txt);
        }
    },
    // エラー要素へのフォーカス
    errorFocus: function(elm) {
        if(this.error_elm == '') {
            this.error_elm = elm;
        }
    }
});

document.observe('dom:loaded', function() {
    
    // 出力スペースの要素名
    var elm = 'fwt_hikaku';
    
    if($(elm)) {
        new hikaku(elm);
    }
});


